
/*
 * Portable Object Compiler (c) 1997.  All Rights Reserved.
 * $Id: rectangl.h,v 1.10 1998/05/19 22:04:12 stes Exp $
 */

/*
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __OBJRECT_H__
#define __OBJRECT_H__

#include "objc.h"

@interface Rectangle : Object
{
  id origin;
  id corner;
}

+ new;
- origin:p corner:q;
+ origin:p corner:q;
- free;

- (int) left;
- (int) right;
- (int) top;
- (int) bottom;
- (int) width;
- (int) height;
- origin;
- corner;

- (BOOL) contains:aPoint;
- (unsigned) hash;
- (BOOL) isEqual:aRectangle;

- moveBy:aPoint;

- printOn:(IOD)aFile;
@end

#endif				/* __OBJRECT_H__ */
